@Forecaster Efficiency, Accuracy and Disagreement: Evidence using Individual-Level Data.
by Michael P. Clements
This version of program for JMCB archive prepared 7th November 2020@

new; cls;	 
outwidth 256;
format /rd 8,3;
library pgraph,co;
#include co.ext;

output file = output1.out reset;
scaling = 1;    @=1: divides forecast errors by average-over-i RMSEs for each t for forecast accuracy calculations. =0: no scaling@;   
topf = 50;		@= no. of Most Prolific Forecasters.@
hcse = 1;       @ =0 OLS SEs; =1 White SEs @
min_no_obs = 10; @minimum number of observations for ORR. And split-sample disagreement@
allforecasters = 0;	  @=1:All. =0:Only those with 12 or more responses@ 
correct_all = 1;  @=0. No correction. =1 MZ always corrects each individual's forecasts, before calculating accuracy and disagreement. =2 Depends on the outcome of a forecast efficiency test@
v =	-1;			  @vintage of actuals to be used. v = 0: 2nd quarterly estimate. v = -1: 1st quarterly estimate@; 
in_sample = 0;    @in-sample or out-of-sample for correcting all forecasts. =1: in-sample. =0:out of sample, recursive estimates after min_no_observations@  
         		  @hh=0: forecasts efficiency-corrected by c_f() are h=0. hh=4 when forecasts efficiency-corrected by c_f() are h=4.@ 
pvstar    =	0.05; @Critical value for rejecting forecast effiicency for efficiency-correction calculation: operative if correct_all = 2@


@Load RTDSMs@
 @all RTDSMs. First column, time, then 65:4 vintage, data from 47:1 to 65:3.
    		  Last column,             18:4 vintage, data from 47:1 to 18:3.@
load y00[] = ..\jmcb18-118\ROUTPUTQvQd.csv;	 @output@
y00 = reshape(y00,287,214);	  
y00 = miss(y00,-9999.00);
y1q = miss(zeros(286,213),0);			  
@Calculate change@
y1q = 100*(ln(y00[2:287,2:214]) -ln(y00[1:286,2:214]));
Dy0 = miss(zeros(144,1),0);
Dy1 = miss(zeros(144,1),0);
Dy2 = miss(zeros(144,1),0);
Dy3 = miss(zeros(144,1),0);
Dy4 = miss(zeros(144,1),0);
j=1; do while j .le 144;   @actuals corresponding to current forecast, next, up to + 4@		@surveys 81:3 to 2017:2@ 
Dy0[j,1] = y1q[137+j,65+j+v];
Dy1[j,1] = y1q[137+j+1,65+j+1+v];
Dy2[j,1] = y1q[137+j+2,65+j+2+v];
Dy3[j,1] = y1q[137+j+3,65+j+3+v];
Dy4[j,1] = y1q[137+j+4,65+j+4+v];
j=j+1;endo;

load y00[] = ..\jmcb18-118\RconQvQd.csv;	 @consumption@
y00 = reshape(y00,287,214);	  
y00 = miss(y00,-9999.00);
y1q = miss(zeros(286,213),0);			  
@Calculate  change@
y1q = 100*(ln(y00[2:287,2:214]) -ln(y00[1:286,2:214]));
Dc0 = miss(zeros(144,1),0);
Dc1 = miss(zeros(144,1),0);
Dc2 = miss(zeros(144,1),0);
Dc3 = miss(zeros(144,1),0);
Dc4 = miss(zeros(144,1),0);
j=1; do while j .le 144;   @actuals corresponding to current forecast, next, up to + 4@		@surveys 81:3 to 2017:2@ 
Dc0[j,1] = y1q[137+j,65+j+v];
Dc1[j,1] = y1q[137+j+1,65+j+1+v];
Dc2[j,1] = y1q[137+j+2,65+j+2+v];
Dc3[j,1] = y1q[137+j+3,65+j+3+v];
Dc4[j,1] = y1q[137+j+4,65+j+4+v];
j=j+1;endo;

load y00i[] = ..\jmcb18-118\Rinvbfqvqd.csv;	 @investment non-res@
y00i = reshape(y00i,287,214);	  
y00i = miss(y00i,-9999.00);
load y00[] = ..\jmcb18-118\Rinvresidqvqd.csv;	 @investment res@
y00 = reshape(y00,287,214);	  
y00 = miss(y00,-9999.00);
y00[.,2:214] = y00[.,2:214] + y00i[.,2:214];		 @residential + non-residential investment@
y1q = miss(zeros(286,213),0);			  
@Calculate  change@
y1q = 100*(ln(y00[2:287,2:214]) -ln(y00[1:286,2:214]));
Di0 = miss(zeros(144,1),0);
Di1 = miss(zeros(144,1),0);
Di2 = miss(zeros(144,1),0);
Di3 = miss(zeros(144,1),0);
Di4 = miss(zeros(144,1),0);
j=1; do while j .le 144;   @actuals corresponding to current forecast, next, up to + 4@		@surveys 81:3 to 2017:2@ 
Di0[j,1] = y1q[137+j,65+j+v];
Di1[j,1] = y1q[137+j+1,65+j+1+v];
Di2[j,1] = y1q[137+j+2,65+j+2+v];
Di3[j,1] = y1q[137+j+3,65+j+3+v];
Di4[j,1] = y1q[137+j+4,65+j+4+v];
j=j+1;endo;



noq = 144;	 @# surveys 81:3 to 2017:2@
@Forecast data on GDP components only in surveys from 81:3 onwards.
End 2017:2 so have actual data from 2018:4 vintage for 2018:2, the longest horizon forecast@

@downloaded December 21 2018@
 @ There are 5243 rows
 (all individuals and all dates (81:3 to 2017:2)) @ 
 load xd[] = ..\jmcb18-118\Individual_RGDP.csv;
  xd = reshape(xd,5243,14);	xd = xd[.,1:12];
/*
@Dubious forecasts replaced with missing values@
  xd[1151,10] = miss(0,0);
*/  
  d = xd[.,1 2 3 5:12];
  d[.,1] = d[.,1] + d[.,2]/10;
  d = d[.,1 3:11];
  d = miss(d,-9999.00);	@Setting missing forecasts to Gauss mv@
 @Structure of d.  col 1 = date; col 2 = id;  col 3 = t-1; cols 4 to 8 are current to +4. Cols 9 and 10 are annual forecasts 
				  Each row refers to forecasts made by a respondent to a given survey@  							
  Fy = d; 

 load xd[] = ..\jmcb18-118\Individual_RCONSUM.csv;
  xd = reshape(xd,5243,12);	xd = xd[.,1:12];			  
/*
@Dubious forecasts replaced with missing values@
  xd[1438,7] = miss(0,0);
  /*xd[4511,9] = miss(0,0);*/ @2013Q1 id 527. Forecast of 93:4 (h=3). Low, but consistent with annual average.
                           When included, causes large discrepancy between qstdc and stdc for 93:4, and a low overall corrn between these estimates@    
*/
  d = xd[.,1 2 3 5:12];
  d[.,1] = d[.,1] + d[.,2]/10;
  d = d[.,1 3:11];
  d = miss(d,-9999.00);	@Setting missing forecasts to Gauss mv@
  Fc = d;

 load xd[] = ..\jmcb18-118\Individual_RNRESIN.csv;
  xd = reshape(xd,5243,12);	xd = xd[.,1:12];
/*
@Dubious forecasts replaced with missing values@
  xd[1296,9] = miss(0,0);
*/
  d = xd[.,1 2 3 5:12];
  d[.,1] = d[.,1] + d[.,2]/10;
  d = d[.,1 3:11];
  d = miss(d,-9999.00);	@Setting missing forecasts to Gauss mv@
  Fi = d;

 load xd[] = ..\jmcb18-118\Individual_RRESINV.csv;
  xd = reshape(xd,5243,12);	xd = xd[.,1:12];			  
  d = xd[.,1 2 3 5:12];
  d[.,1] = d[.,1] + d[.,2]/10;
  d = d[.,1 3:11];
  d = miss(d,-9999.00);	@Setting missing forecasts to Gauss mv@
  Fi[.,3:10] = Fi[.,3:10] + d[.,3:10];
 

@delete id 532, who makes only 5 h=4 consumption forecasts@
 Fc = delif(Fc,Fc[.,2] .== 532);
 Fi = delif(Fi,Fi[.,2] .== 532);
 Fy = delif(Fy,Fy[.,2] .== 532);
  
@sort individuals in terms of # responses to 90:4 to 2017:2 surveys, and then optionally select those who responded 12 or more times@  
maxi= maxc(Fy[.,2]);	@highest respondent id@
resps = seqa(1,1,maxi);
Fy904_172 = selif(Fy[.,2],Fy[.,1] .ge 1990.4);
nresps = resps~sumc((resps .eq Fy904_172')');
nids =  sumc(nresps[.,2] .gt 0);
ids = rev(sortc(nresps,2));
ids = ids[1:nids,.]; @ids with most responses: no of responses, to least.@ 
nf = nids;
if allforecasters;
nf =nids;
else;
nf = sumc(ids[.,2] .gt 11);	 @respondents filed 12 or more returns@
@keep only responses from the top nf respondents@ 
select_i = Fy[.,2] .eq ids[1:nf,1]';
Fc = selif(Fc,sumc(select_i'));
Fi = selif(Fi,sumc(select_i'));
Fy = selif(Fy,sumc(select_i'));

ids = ids[1:nf,.];
endif;

FDc0 = miss(zeros(noq,nf),0);	@forecast of current quarter qly change@
FDc1 = miss(zeros(noq,nf),0);	@forecast of next (+1) quarter qly change@
FDc2 = miss(zeros(noq,nf),0);	@forecast of +2 quarter qly  change@
FDc3 = miss(zeros(noq,nf),0);	@forecast of +3 quarter qly  change@
FDc4 = miss(zeros(noq,nf),0);	@forecast of +4 quarter qly  change@

FDi0 = miss(zeros(noq,nf),0);	@forecast of current quarter qly  change@
FDi1 = miss(zeros(noq,nf),0);	@forecast of next (+1) quarter qly  change@
FDi2 = miss(zeros(noq,nf),0);	@forecast of +2 quarter qly  change@
FDi3 = miss(zeros(noq,nf),0);	@forecast of +3 quarter qly  change@
FDi4 = miss(zeros(noq,nf),0);	@forecast of +4 quarter qly  change@

FDy0 = miss(zeros(noq,nf),0);	@forecast of current quarter qly  change@
FDy1 = miss(zeros(noq,nf),0);	@forecast of next (+1) quarter qly  change@
FDy2 = miss(zeros(noq,nf),0);	@forecast of +2 quarter qly  change@
FDy3 = miss(zeros(noq,nf),0);	@forecast of +3 quarter qly  change@
FDy4 = miss(zeros(noq,nf),0);	@forecast of +4 quarter qly  change@

idmatrix_c = miss(zeros(noq,nf),0);	@ identifiers of respondents@
idmatrix_i = miss(zeros(noq,nf),0);	@ identifiers of respondents@
idmatrix_y = miss(zeros(noq,nf),0);	@ identifiers of respondents@


@for a given row (= survey date), the elements in a given column
correspond to the same forecaster. But each column does not correspond to a specific
forecaster@;

ydate = 1981.3;	
q=1; w=1;  dates_c = ydate;
j=1; do while j <= rows(Fc);
if Fc[j,1] == ydate;
  idmatrix_c[q,w]   = Fc[j,2];  
  FDc0[q,w] = 100*ln(Fc[j,4]/Fc[j,3]);
  FDc1[q,w] = 100*ln(Fc[j,5]/Fc[j,4]);
  FDc2[q,w] = 100*ln(Fc[j,6]/Fc[j,5]);
  FDc3[q,w] = 100*ln(Fc[j,7]/Fc[j,6]);
  FDc4[q,w] = 100*ln(Fc[j,8]/Fc[j,7]);
  w=w+1; 
  else; ydate = Fc[j,1]; q=q+1; j=j-1; w=1; dates_c = dates_c|ydate;    
  endif;
j=j+1;endo;


ydate = 1981.3;	
q=1; w=1;  dates_i = ydate;
j=1; do while j <= rows(Fi);
if Fi[j,1] == ydate;
  idmatrix_i[q,w]   = Fi[j,2];  
  FDi0[q,w] = 100*ln(Fi[j,4]/Fi[j,3]);
  FDi1[q,w] = 100*ln(Fi[j,5]/Fi[j,4]);
  FDi2[q,w] = 100*ln(Fi[j,6]/Fi[j,5]);
  FDi3[q,w] = 100*ln(Fi[j,7]/Fi[j,6]);
  FDi4[q,w] = 100*ln(Fi[j,8]/Fi[j,7]);
  w=w+1; 
  else; ydate = Fi[j,1]; q=q+1; j=j-1; w=1; dates_i = dates_i|ydate;    
  endif;
j=j+1;endo;

ydate = 1981.3;	
q=1; w=1;  dates_y = ydate;
j=1; do while j <= rows(Fy);
if Fy[j,1] == ydate;
  idmatrix_y[q,w]   = Fy[j,2];  
  FDy0[q,w] = 100*ln(Fy[j,4]/Fy[j,3]);
  FDy1[q,w] = 100*ln(Fy[j,5]/Fy[j,4]);
  FDy2[q,w] = 100*ln(Fy[j,6]/Fy[j,5]);
  FDy3[q,w] = 100*ln(Fy[j,7]/Fy[j,6]);
  FDy4[q,w] = 100*ln(Fy[j,8]/Fy[j,7]);
  w=w+1; 
  else; ydate = Fy[j,1]; q=q+1; j=j-1; w=1; dates_y = dates_y|ydate;    
  endif;
j=j+1;endo;


 /**********************Sorting forecasts by individual**********************/
   i_FDc0 =  miss(zeros(noq,nf),0);
   i_FDc1 =  miss(zeros(noq,nf),0);
   i_FDc2 =  miss(zeros(noq,nf),0);
   i_FDc3 =  miss(zeros(noq,nf),0);
   i_FDc4 =  miss(zeros(noq,nf),0);
  q=1; do while q <= noq;
	w=1;
	do while w <= nf; 		
				   j=1; do while j <= nf;		   		
				            if idmatrix_c[q,j] == ids[w,1];
						   i_FDc0[q,w] =	  FDc0[q,j];
						   i_FDc1[q,w] =	  FDc1[q,j];
						   i_FDc2[q,w] =	  FDc2[q,j];
						   i_FDc3[q,w] =	  FDc3[q,j];
						   i_FDc4[q,w] =	  FDc4[q,j];						
							j = nf+1; 
						    endif;
				   j=j+1; endo;
	w=w+1;	endo;				   
  q=q+1; endo;


   i_FDi0 =  miss(zeros(noq,nf),0);
   i_FDi1 =  miss(zeros(noq,nf),0);
   i_FDi2 =  miss(zeros(noq,nf),0);
   i_FDi3 =  miss(zeros(noq,nf),0);
   i_FDi4 =  miss(zeros(noq,nf),0);
  q=1; do while q <= noq;
	w=1;
	do while w <= nf; 		
				   j=1; do while j <= nf;		   		
				            if idmatrix_i[q,j] == ids[w,1];
						   i_FDi0[q,w] =	  FDi0[q,j];
						   i_FDi1[q,w] =	  FDi1[q,j];
						   i_FDi2[q,w] =	  FDi2[q,j];
						   i_FDi3[q,w] =	  FDi3[q,j];
						   i_FDi4[q,w] =	  FDi4[q,j];
							j = nf+1; 
						    endif;
				   j=j+1; endo;
	w=w+1;	endo;				   
  q=q+1; endo;


  
   i_FDy0 =  miss(zeros(noq,nf),0);
   i_FDy1 =  miss(zeros(noq,nf),0);
   i_FDy2 =  miss(zeros(noq,nf),0);
   i_FDy3 =  miss(zeros(noq,nf),0);
   i_FDy4 =  miss(zeros(noq,nf),0); 
  q=1; do while q <= noq;
	w=1;
	do while w <= nf; 		
				   j=1; do while j <= nf;		   		
				            if idmatrix_y[q,j] == ids[w,1];
						   i_FDy0[q,w] =	  FDy0[q,j];
						   i_FDy1[q,w] =	  FDy1[q,j];
						   i_FDy2[q,w] =	  FDy2[q,j];
						   i_FDy3[q,w] =	  FDy3[q,j];
						   i_FDy4[q,w] =	  FDy4[q,j];
								j = nf+1; 
						    endif;
				   j=j+1; endo;
	w=w+1;	endo;				   
  q=q+1; endo;
   
dates = dates_c;

mdD0 = miss(zeros(107,nf),0);  	@multivariate disagreement: rows = survey quarter, cols = individuals@ 
mdD4 = miss(zeros(107,nf),0);  
mdD0d = miss(zeros(107,nf),0);  @multivariate disagreement with diagonal S matrix: rows = survey quarter, cols = individuals@ 
mdD4d = miss(zeros(107,nf),0);  

trace0 = miss(zeros(107,nf),0); @Sum (over variables) of sqd errors, h=0. Rows = survey quarter, cols = individuals@ 
trace4 = miss(zeros(107,nf),0); @Sum (over variables) of sqd errors, h=4. Rows = survey quarter, cols = individuals@ 

@MZ-correction of all an individual's forecasts.@

@corrected versions - real time@
 @beta coefficients@
 beta_c0 = miss(zeros(nf,1),0);
 beta_i0 = miss(zeros(nf,1),0);
 beta_y0 = miss(zeros(nf,1),0);
 beta_c4 = miss(zeros(nf,1),0);
 beta_i4 = miss(zeros(nf,1),0);
 beta_y4 = miss(zeros(nf,1),0);

 i_FDc0C =	  i_FDc0 ;
 i_FDi0C =	  i_FDi0 ;
 i_FDy0C =	  i_FDy0 ;
        	          
 i_FDc4C =	  i_FDc4 ;
 i_FDi4C =	  i_FDi4 ;
 i_FDy4C =	  i_FDy4 ;

 i=1; do while i le nf;
 {i_FDc0C[.,i], beta_c0[i,1]} = c_f(Dc0~i_FDc0[.,i],in_sample,0);
 {i_FDi0C[.,i], beta_i0[i,1]} = c_f(Di0~i_FDi0[.,i],in_sample,0);
 {i_FDy0C[.,i], beta_y0[i,1]} = c_f(Dy0~i_FDy0[.,i],in_sample,0);
    					 
 {i_FDc4C[.,i], beta_c4[i,1]} = c_f(Dc4~i_FDc4[.,i],in_sample,4);
 {i_FDi4C[.,i], beta_i4[i,1]} = c_f(Di4~i_FDi4[.,i],in_sample,4);
 {i_FDy4C[.,i], beta_y4[i,1]} = c_f(Dy4~i_FDy4[.,i],in_sample,4);
 i=i+1; endo;

 
@correct_all = 0 Never correct. =1 Always correct. =2 Depends on Forecast-Efficiency test@ 
if correct_all == 1;
 i=1; do while i le nf;
 {i_FDc0[.,i], a} = c_f(Dc0~i_FDc0[.,i],in_sample,0);
 {i_FDi0[.,i], a} = c_f(Di0~i_FDi0[.,i],in_sample,0);
 {i_FDy0[.,i], a} = c_f(Dy0~i_FDy0[.,i],in_sample,0);
			   
 {i_FDc4[.,i], a} = c_f(Dc4~i_FDc4[.,i],in_sample,4);
 {i_FDi4[.,i], a} = c_f(Di4~i_FDi4[.,i],in_sample,4);
 {i_FDy4[.,i], a} = c_f(Dy4~i_FDy4[.,i],in_sample,4);
 i=i+1; endo;
elseif correct_all == 2;

   i=1; do while i le nf;
  TestRc = MZa(Dc0[38:144,1]~i_FDc0[38:144,i]~i_FDc1[37:143,i]~i_FDc2[36:142,i]~i_FDc3[35:141,i]~i_FDc4[34:140,i]); 
  TestRi = MZa(Di0[38:144,1]~i_FDi0[38:144,i]~i_FDi1[37:143,i]~i_FDi2[36:142,i]~i_FDi3[35:141,i]~i_FDi4[34:140,i]); 
  TestRy = MZa(Dy0[38:144,1]~i_FDy0[38:144,i]~i_FDy1[37:143,i]~i_FDy2[36:142,i]~i_FDy3[35:141,i]~i_FDy4[34:140,i]); 


  i_FDc0[.,i] =	  i_FDc0[.,i]  -  (	i_FDc0[.,i]  -	 i_FDc0C[.,i])*(TestRc[1,2] .le pvstar);	@if reject FE test, with p_value < pvstar, use corrected forecast@
  i_FDi0[.,i] =	  i_FDi0[.,i]  -  (	i_FDi0[.,i]  -	 i_FDi0C[.,i])*(TestRi[1,2] .le pvstar);
  i_FDy0[.,i] =	  i_FDy0[.,i]  -  (	i_FDy0[.,i]  -	 i_FDy0C[.,i])*(TestRy[1,2] .le pvstar);
    		 	    		 		  		    	   		   
  i_FDc4[.,i] =	  i_FDc4[.,i]  -  (	i_FDc4[.,i]  -	 i_FDc4C[.,i])*(TestRc[1,6] .le pvstar);
  i_FDi4[.,i] =	  i_FDi4[.,i]  -  (	i_FDi4[.,i]  -	 i_FDi4C[.,i])*(TestRi[1,6] .le pvstar);
  i_FDy4[.,i] =	  i_FDy4[.,i]  -  (	i_FDy4[.,i]  -	 i_FDy4C[.,i])*(TestRy[1,6] .le pvstar);
  i=i+1; endo;
endif;


y0_dis  = miss(zeros(144,1),0);	   @stdc of reported, y0@
y0C_dis = miss(zeros(144,1),0);	   @stdc of corrected@
y0_E 	= miss(zeros(144,1),0);	   @average absolute size of correction@ 
i0_E    = miss(zeros(144,1),0);
c0_E    = miss(zeros(144,1),0); 
y4_dis  = miss(zeros(144,1),0);	   @stdc of reported, y4@
y4C_dis = miss(zeros(144,1),0);	   @stdc of corrected@
y4_E 	= miss(zeros(144,1),0);	   @average absolute size of correction@ 
i4_E    = miss(zeros(144,1),0);
c4_E    = miss(zeros(144,1),0); 

c0_dis	= miss(zeros(144,1),0);	   @stdc of reported, c0@
i0_dis	= miss(zeros(144,1),0);	   @stdc of reported, y0@
c4_dis	= miss(zeros(144,1),0);	   @stdc of reported, c4@
i4_dis	= miss(zeros(144,1),0);	   @stdc of reported, y40@


j=1; do while j .le 144;
y0_dis[j,1]  = stdc(packr(i_FDy0[j,.]'));
y4_dis[j,1]  = stdc(packr(i_FDy4[j,.]'));
c0_dis[j,1]  = stdc(packr(i_FDc0[j,.]'));
c4_dis[j,1]  = stdc(packr(i_FDc4[j,.]'));
i0_dis[j,1]  = stdc(packr(i_FDi0[j,.]'));
i4_dis[j,1]  = stdc(packr(i_FDi4[j,.]'));


y0C_dis[j,1] = stdc(packr(i_FDy0C[j,.]'));
y4C_dis[j,1] = stdc(packr(i_FDy4C[j,.]'));

c0_E[j,1]	 = meanc(abs(packr(i_FDc0[j,.]'-i_FDc0C[j,.]')));
c4_E[j,1]	 = meanc(abs(packr(i_FDc4[j,.]'-i_FDc4C[j,.]')));
i0_E[j,1]	 = meanc(abs(packr(i_FDi0[j,.]'-i_FDi0C[j,.]')));
i4_E[j,1]	 = meanc(abs(packr(i_FDi4[j,.]'-i_FDi4C[j,.]')));
y0_E[j,1]	 = meanc(abs(packr(i_FDy0[j,.]'-i_FDy0C[j,.]')));
y4_E[j,1]	 = meanc(abs(packr(i_FDy4[j,.]'-i_FDy4C[j,.]')));
j=j+1; endo;


@Calculate normalisation for individual forecast errors, depending on t. RMSE over nf (i.e., all who respond .ge 12 times)@
@the forecasts will have been efficiency corrected if correct_all =1@ 
rmse_c_0 = miss(zeros(144,1),0);   @RMSE across individuals@
rmse_i_0 = miss(zeros(144,1),0);				 
rmse_y_0 = miss(zeros(144,1),0);
rmse_c_4 = miss(zeros(144,1),0);
rmse_i_4 = miss(zeros(144,1),0);
rmse_y_4 = miss(zeros(144,1),0);

aafe_c_0 = miss(zeros(144,1),0);   @Average absolute forecast error across individuals@
aafe_i_0 = miss(zeros(144,1),0);				 
aafe_y_0 = miss(zeros(144,1),0);
aafe_c_4 = miss(zeros(144,1),0);
aafe_i_4 = miss(zeros(144,1),0);
aafe_y_4 = miss(zeros(144,1),0);

j=1; do while j <= 144;
rmse_c_0[j,1] = rmse(Dc0[j,1],i_FDc0[j,1:nf]);
rmse_i_0[j,1] = rmse(Di0[j,1],i_FDi0[j,1:nf]);
rmse_y_0[j,1] = rmse(Dy0[j,1],i_FDy0[j,1:nf]);
rmse_c_4[j,1] = rmse(Dc4[j,1],i_FDc4[j,1:nf]);
rmse_i_4[j,1] = rmse(Di4[j,1],i_FDi4[j,1:nf]);
rmse_y_4[j,1] = rmse(Dy4[j,1],i_FDy4[j,1:nf]);

aafe_c_0[j,1] = aafe(Dc0[j,1],i_FDc0[j,1:nf]);
aafe_i_0[j,1] = aafe(Di0[j,1],i_FDi0[j,1:nf]);
aafe_y_0[j,1] = aafe(Dy0[j,1],i_FDy0[j,1:nf]);
aafe_c_4[j,1] = aafe(Dc4[j,1],i_FDc4[j,1:nf]);
aafe_i_4[j,1] = aafe(Di4[j,1],i_FDi4[j,1:nf]);
aafe_y_4[j,1] = aafe(Dy4[j,1],i_FDy4[j,1:nf]);

j=j+1; endo;


fe_c0 = miss(0,0);
fe_i0 = miss(0,0);
fe_y0 = miss(0,0);
fe_c4 = miss(0,0);
fe_i4 = miss(0,0);
fe_y4 = miss(0,0);

aac0  = miss(0,0); @absolute corrections c0@ 
aai0  = miss(0,0);
aay0  = miss(0,0);
aac4  = miss(0,0);
aai4  = miss(0,0);
aay4  = miss(0,0);

j=38; do while j <= 144;
fe_c0 = fe_c0|(Dc0[j,1]-i_FDc0[j,1:nf]');
fe_i0 = fe_i0|(Di0[j,1]-i_FDi0[j,1:nf]');
fe_y0 = fe_y0|(Dy0[j,1]-i_FDy0[j,1:nf]');
fe_c4 = fe_c4|(Dc4[j,1]-i_FDc4[j,1:nf]');
fe_i4 = fe_i4|(Di4[j,1]-i_FDi4[j,1:nf]');
fe_y4 = fe_y4|(Dy4[j,1]-i_FDy4[j,1:nf]');

aac0 = aac0|packr(i_FDc0[j,.]'-i_FDc0C[j,.]');
aai0 = aai0|packr(i_FDi0[j,.]'-i_FDi0C[j,.]');
aay0 = aay0|packr(i_FDy0[j,.]'-i_FDy0C[j,.]');
aac4=  aac4|packr(i_FDc4[j,.]'-i_FDc4C[j,.]');
aai4 = aai4|packr(i_FDi4[j,.]'-i_FDi4C[j,.]');
aay4 = aay4|packr(i_FDy4[j,.]'-i_FDy4C[j,.]');



j=j+1; endo;


avmean = meanc(packr(Dc0[38:144,1]))~meanc(packr(Di0[38:144,1]))~meanc(packr(Dy0[38:144,1]))~meanc(packr(Dc4[38:144,1]))~meanc(packr(Di4[38:144,1]))~meanc(packr(Dy4[38:144,1]));
avaa   = meanc(abs(packr(aac0)))~meanc(abs(packr(aai0)))~meanc(abs(packr(aay0)))~meanc(abs(packr(aac4)))~meanc(abs(packr(aai4)))~meanc(abs(packr(aay4)));
avedisag = meanc(c0_dis[38:144,1])~meanc(i0_dis[38:144,1])~meanc(y0_dis[38:144,1])~meanc(c4_dis[38:144,1])~meanc(i4_dis[38:144,1])~meanc(y4_dis[38:144,1]);

"Table 3";
@Mean actual value
Mean absolute corection
MAE
MAE/Actual Value
Disagreement@;
ttab = avmean;
ttab = ttab|avaa;
ttab = ttab|(meanc(abs(packr(fe_c0)))~meanc(abs(packr(fe_i0)))~meanc(abs(packr(fe_y0)))~meanc(abs(packr(fe_c4)))~meanc(abs(packr(fe_i4)))~meanc(abs(packr(fe_y4))));
ttab = ttab|(ttab[3,.]./avmean);
ttab = ttab|avedisag;
tex_table(ttab);

output file = forecasts.out reset;
"rmse's: c0: i0: y0: c4: i4: y4. 1990:4 to 2017:2 ";
zz=rmse_c_0[38:144,1]~rmse_i_0[38:144,1]~rmse_y_0[38:144,1]~rmse_c_4[38:144,1]~rmse_i_4[38:144,1]~rmse_y_4[38:144,1];
ma11(zz);
"disagreement of: reported output h=0: corrected output h=0: reported output h=4: corrected output h=4. 1990:4 to 2017:2"; 
zz=y0_dis[38:144,1]~y0C_dis[38:144,1]~y4_dis[38:144,1]~y4C_dis[38:144,1];
ma11(zz);
"average absolute corections to c0: c4: i0: i4: y0: y4";
zz=c0_E[38:144,1]~c4_E[38:144,1]~i0_E[38:144,1]~i4_E[38:144,1]~y0_E[38:144,1]~y4_E[38:144,1];
ma11(zz);
"Ratio average absolute corections to average absoluted forecast errors, for: c0: c4: i0: i4: y0: y4";
zz=c0_E[38:144,1]./aafe_c_0[38:144,1]~c4_E[38:144,1]./aafe_c_4[38:144,1]~i0_E[38:144,1]./aafe_i_0[38:144,1]~i4_E[38:144,1]./aafe_i_4[38:144,1]~y0_E[38:144,1]./aafe_y_0[38:144,1]~y4_E[38:144,1]./aafe_y_4[38:144,1];
ma11(zz);

"beta parameters from efficiency correction.c0, i0, y0, c4, i4, y4"; 
packr(beta_c0~beta_i0~beta_y0~beta_c4~beta_i4~beta_y4);

output file = output1.out on;



"Reported and Corrected Forecasts for 426 (id = 1)";
"Pairs: cons h=0, inv h=0, output h=0, cons h=4, inv h=0, output h=0";
id = 1;" in_sample = ";;in_sample;
ids[id,.];
dates~Dc0~Dc4~i_FDc0[.,id]~i_FDc0C[.,id]~i_FDi0[.,id]~i_FDi0C[.,id]~i_FDy0[.,id]~i_FDy0C[.,id]~i_FDc4[.,id]~i_FDc4C[.,id]~i_FDi4[.,id]~i_FDi4C[.,id]~i_FDy4[.,id]~i_FDy4C[.,id];

@Heterogeneity of forecasters@
j=38; do while j .le 144;
   
   w = FDc0[j,.]'~FDi0[j,.]'~FDy0[j,.]'; 
   w= packr(w);
   w = w - meanc(w)';
   Sth0  =  w'w/(rows(w));

   w = FDc4[j,.]'~FDi4[j,.]'~FDy4[j,.]'; 
   w= packr(w);
   w = w - meanc(w)';
   Sth4  =  w'w/(rows(w));

   Sth0d = diagrv(eye(3),diag(Sth0));
   Sth4d = diagrv(eye(3),diag(Sth4));
 
   i=1; do while i .le nf;
   w = i_FDc0[j,i]~i_FDi0[j,i]~i_FDy0[j,i];
   w= w - meanc(packr(FDc0[j,.]'~FDi0[j,.]'~FDy0[j,.]'))';  
	
   if ismiss(w);
   mdD0[j-37,i] = miss(0,0);
   mdD0d[j-37,i] = miss(0,0);
   else;
   mdD0[j-37,i]  = SQRT(det(w*invpd(Sth0)*w'));
   mdD0d[j-37,i] = SQRT(det(w*invpd(Sth0d)*w'));	 @multi disag with diagonal S_{th}@
   endif;

   
   w = i_FDc4[j,i]~i_FDi4[j,i]~i_FDy4[j,i];
   w = w - meanc(packr(FDc4[j,.]'~FDi4[j,.]'~FDy4[j,.]'))';   

   if ismiss(w);
   mdD4[j-37,i] = miss(0,0);
   mdD4d[j-37,i] = miss(0,0);
   else;
   mdD4[j-37,i] = SQRT(det(w*invpd(Sth4)*w'));
   mdD4d[j-37,i] = SQRT(det(w*invpd(Sth4d)*w'));
   endif;

   i=i+1; endo;

j=j+1; endo;

wsort = zeros(1,3);
i = 1; do while i .le nf;
wsort  = wsort|(ids[i,1]~rows(packr(mdD0[.,i]))~rows(packr(mdD4[.,i])));
i=i+1; endo;
wsort  = wsort[2:nf+1,.];
wsorted  = rev(sortc(seqa(1,1,nf)~wsort,3));

"average number of forecasts per forecaster for 25 most prolific, 44 most prolific, 50 most prolific, for h=0";
meanc(wsorted[1:25,3]);;meanc(wsorted[1:44,3]);;meanc(wsorted[1:50,3]);
"max";
maxc(wsorted[1:25,3]);;maxc(wsorted[1:44,3]);;maxc(wsorted[1:50,3]);
"min";
minc(wsorted[1:25,3]);;minc(wsorted[1:44,3]);;minc(wsorted[1:50,3]);

mdD0Z  = mdD0[.,wsorted[1:topf,1]']; 	@mdD0Z etc ordered such that col 1 is most prolific (at h=0)@ 
mdD4Z  = mdD4[.,wsorted[1:topf,1]']; 
mdD0Zd = mdD0d[.,wsorted[1:topf,1]']; 	@mdD0Zd etc ordered such that col 1 is most prolific (at h=0)@ 
mdD4Zd = mdD4d[.,wsorted[1:topf,1]']; 
ids_prol = ids[wsorted[1:topf,1],1];
newid =  wsorted[1:topf,1];

np = rows(ids_prol);
topfs = np;		    


@Calculate forecast accuracy of the ids_prol individuals@;
Acc_i_0  = miss(zeros(np,10),0);  		 @id, Trace of MSFEM, h=0; det of MSFEM,   h=0 @ 
Acc_i_4  = miss(zeros(np,10),0);  		 @id, Trace of MSFEM, h=4; det of MSFEM,   h=4 @ 

wholes = seqa(38,1,107); 
short1 = seqa(38,1,54);
short2 = seqa(92,1,53); 

i=1; do while i <= np;

e =  (i_FDc0[.,newid[i,1]]~i_FDi0[.,newid[i,1]]~i_FDy0[.,newid[i,1]])-(Dc0[.,1]~Di0[.,1]~Dy0[.,1]);

if scaling;
e = e./(rmse_c_0~rmse_i_0~rmse_y_0);
endif;
Acc_i_0[i,.] = ids_prol[i,1]~ForecAcc(e[wholes,.])~ForecAcc(e[short1,.])~ForecAcc(e[short2,.]); 
trace0[.,i]   = trace_errors(e[38:144,.]);

e = (i_FDc4[.,newid[i,1]]~i_FDi4[.,newid[i,1]]~i_FDy4[.,newid[i,1]])-(Dc4[.,1]~Di4[.,1]~Dy4[.,1]);
if scaling; 
e = e./(rmse_c_4~rmse_i_4~rmse_y_4);
endif;
Acc_i_4[i,.] = ids_prol[i,1]~ForecAcc(e[wholes,.])~ForecAcc(e[short1,.])~ForecAcc(e[short2,.]);
trace4[.,i]   = trace_errors(e[38:144,.]);

i=i+1;	 endo;

"Accuracy - scaled if scaling =1. ";
"Accuracy. h= 0, | id | 90:4-2017:2 TMSFE, DMSFEM n |  90:4-2004:1 TMSFE, DMSFEM n |  2004:2-2017:2 TMSFE, DMSFEM n ";
ww = Acc_i_0[.,1:10];
tex_table(sortc(ww,1));

"Accuracy. h= 4, | id | 90:4-2017:2 TMSFE, DMSFEM n |  90:4-2004:1 TMSFE, DMSFEM n |  2004:2-2017:2 TMSFE, DMSFEM n ";
ww = Acc_i_4[.,1:10];
tex_table(sortc(ww,1));

"Accuracy. Rankings	";
"Accuracy. h= 0, | id | 90:4-2017:2 TMSFE, DMSFEM n |  90:4-2004:1 TMSFE, DMSFEM n |  2004:2-2017:2 TMSFE, DMSFEM n ";
ww = Acc_i_0[.,1]~rankindx(Acc_i_0[.,2],1)~rankindx(Acc_i_0[.,3],1)~Acc_i_0[.,4]~rankindx(Acc_i_0[.,5],1)~rankindx(Acc_i_0[.,6],1)~Acc_i_0[.,7]~rankindx(Acc_i_0[.,8],1)~rankindx(Acc_i_0[.,9],1)~Acc_i_0[.,10];
tex_table(sortc(ww,1));

"Accuracy. h= 4, | id | 90:4-2017:2 TMSFE, DMSFEM n |  90:4-2004:1 TMSFE, DMSFEM n |  2004:2-2017:2 TMSFE, DMSFEM n ";
ww = Acc_i_4[.,1]~rankindx(Acc_i_4[.,2],1)~rankindx(Acc_i_4[.,3],1)~Acc_i_4[.,4]~rankindx(Acc_i_4[.,5],1)~rankindx(Acc_i_4[.,6],1)~Acc_i_4[.,7]~rankindx(Acc_i_4[.,8],1)~rankindx(Acc_i_4[.,9],1)~Acc_i_4[.,10];
tex_table(sortc(ww,1));

@for h=0@;
acc=sortc(Acc_i_0~seqa(1,1,np),2); @sort on full-sample, Trace@
mid_acc0 = acc[(np+1)/2,11]; @position of middle in ids_prol@
id_mid = ids_prol[mid_acc0,1];
"id of middle accuracy h=0 forecaster ";; id_mid;
"mid_acc0";;mid_acc0;
@for h=4@;
acc=sortc(Acc_i_4~seqa(1,1,np),2); @sort on full-sample, Trace@
mid_acc4 = acc[(np+1)/2,11]; @position of middle in ids_prol@
id_mid = ids_prol[mid_acc4,1];
"id of middle accuracy h=4 forecaster ";; id_mid;
"mid_acc4";;mid_acc4;

DM_test_res0 = miss(zeros(np,3),0);
DM_test_res4 = miss(zeros(np,3),0);

i=1; do while i .le np;
/*
DM_test_res0[i,.] = ids_prol[i,1]~DM_test(trace0[.,mid_acc0],trace0[.,i],0);  @compares "i" to the middle-accuracy forecaster@;	
DM_test_res4[i,.] = ids_prol[i,1]~DM_test(trace4[.,mid_acc4],trace4[.,i],3);	 	  
*/
DM_test_res0[i,.] = ids_prol[i,1]~DM_test(trace0[.,17],trace0[.,i],0);		  @compares "i"	to forecaster "17"@;
DM_test_res4[i,.] = ids_prol[i,1]~DM_test(trace4[.,6],trace4[.,i],3);	 	  

i=i+1; endo;

"ids_prol[17,1]";;	  ids_prol[17,1];  
"ids_prol[6,1]  ";;	  ids_prol[6,1];    

"DM tests: median - i. h=0";
"Part of Table 3 in the appendix"; 
zzz = sortc(DM_test_res0,1);
tex_table(zzz);

"h=0. Prop > 0.95, 0.975. Prop < 0.05, 0.025";
meanc(zzz[.,2] .gt 0.95);;meanc(zzz[.,2] .gt 0.975);;meanc(zzz[.,2] .lt 0.05);;meanc(zzz[.,2] .lt 0.025);

zzz = sortc(DM_test_res4,1);
"DM tests: median - i. h=4";
"Part of Table 4 in the appendix"; 

tex_table(zzz);

"h=4. Prop > 0.95, 0.975. Prop < 0.05, 0.025";
meanc(zzz[.,2] .gt 0.95);;meanc(zzz[.,2] .gt 0.975);;meanc(zzz[.,2] .lt 0.05);;meanc(zzz[.,2] .lt 0.025);


tabD  = miss(zeros(np,4),0);
tabD1 = miss(zeros(np,3),0);
tabD2 = miss(zeros(np,3),0);

tabDd  = miss(zeros(np,4),0);
tabD1d = miss(zeros(np,3),0);
tabD2d = miss(zeros(np,3),0);


@calculate smallest and largest average mdD0Z over individuals@
ave_mdD0 = miss(zeros(np,2),0);
ave_mdD4 = miss(zeros(np,2),0);
ave_mdD0d = miss(zeros(np,2),0);
ave_mdD4d = miss(zeros(np,2),0);
i=1; do while i <= np;
ave_mdD0[i,.] = meanc(packr(mdD0Z[.,i]))~ids_prol[i,1];
ave_mdD4[i,.] = meanc(packr(mdD4Z[.,i]))~ids_prol[i,1];
ave_mdD0d[i,.] = meanc(packr(mdD0Zd[.,i]))~ids_prol[i,1];
ave_mdD4d[i,.] = meanc(packr(mdD4Zd[.,i]))~ids_prol[i,1];
i=i+1; endo;
print ave_mdD0;
small_mdD0 = minindc(ave_mdD0[.,1]);
large_mdD0 = maxindc(ave_mdD0[.,1]);
"small_mdD0";; 	small_mdD0;
"id of resp. with smallest"; id_small_mdD0 = ids_prol[small_mdD0,1];  id_small_mdD0;
"large_mdD0";; 	large_mdD0;
"id of resp. with largest";  id_large_mdD0 = ids_prol[large_mdD0,1];  id_large_mdD0;

t6 = spearman(rankindx(Acc_i_0[.,2],1),rankindx(ave_mdD0[.,1],1)); 
t6 = t6~spearman(rankindx(Acc_i_0[.,3],1),rankindx(ave_mdD0[.,1],1)); 
t6 = t6~spearman(rankindx(Acc_i_4[.,2],1),rankindx(ave_mdD4[.,1],1)); 
t6 = t6~spearman(rankindx(Acc_i_4[.,3],1),rankindx(ave_mdD4[.,1],1)); 

"Table 7";
tex_table(t6);

"Table 5. ";
"Persistence of Accuracy Rankings ";
w = packr(Acc_i_0[.,5 8]); 							  @gets rid of sub-sample missings@
t5 = spearman(rankindx(w[.,1],1),rankindx(w[.,2],1)); 

w = packr(Acc_i_0[.,6 9]); 
t5 = t5~spearman(rankindx(w[.,1],1),rankindx(w[.,2],1)); 

w = packr(Acc_i_4[.,5 8]);
t5 = t5~spearman(rankindx(w[.,1],1),rankindx(w[.,2],1)); 

w = packr(Acc_i_4[.,6 9]);
t5 = t5~spearman(rankindx(w[.,1],1),rankindx(w[.,2],1)); 
tex_table(t5);

mdsorted = sortc(ave_mdD0~seqa(1,1,np),1);
middle_mdD0 = mdsorted[(np+1)/2,3];
"middle_mdD0 ";; middle_mdD0; 
"id of median resp"; id_middle_mdD0 = ids_prol[middle_mdD0,1]; id_middle_mdD0; 
mddsorted = sortc(ave_mdD0d~seqa(1,1,np),1);
middle_mdD0d = mddsorted[(np+1)/2,3];

mdsorted4 = sortc(ave_mdD4~seqa(1,1,np),1);		
middle_mdD4 = mdsorted4[(np+1)/2,3];
"middle_mdD4 ";; middle_mdD4; 
"id of median resp"; id_middle_mdD4 = ids_prol[middle_mdD4,1]; id_middle_mdD4; 

@Summary statistics of individuals' multivariate disagreement:@
i = 1; do while i .le np;


 @Compares "i" to middle forecaster@
 tabD[i,.] = ids_prol[i,1]~meanc(packr(mdD0Z[1:107,i]))~EqMeans(mdD0Z[.,middle_mdD0],mdD0Z[.,i],1)~EqMeans(mdD4Z[.,middle_mdD4],mdD4Z[.,i],1);	 @Last term = 4 gives AC@

 /*
 @Compares "i" to specified forecaster@
 tabD[i,.] = ids_prol[i,1]~meanc(packr(mdD0Z[1:107,i]))~EqMeans(mdD0Z[.,40],mdD0Z[.,i],1)~EqMeans(mdD4Z[.,12],mdD4Z[.,i],4);	 @Last term = 4 gives AC@
 */
 
 tabDd[i,.] = ids_prol[i,1]~meanc(packr(mdD0Zd[1:107,i]))~EqMeans(mdD0Zd[.,middle_mdD0d],mdD0Zd[.,i],1)~meanc(packr(mdD4Zd[1:107,i]));


 if rows(packr(mdD0Z[1:54,i])) .lt min_no_obs;
 tabD1[i,.] = ids_prol[i,1]~miss(zeros(1,2),0);
tabD1d[i,.] = ids_prol[i,1]~miss(zeros(1,2),0);
 else;
 tabD1[i,.] = ids_prol[i,1]~meanc(packr(mdD0Z[1:54,i]))~meanc(packr(mdD4Z[1:54,i]));          
tabD1d[i,.] = ids_prol[i,1]~meanc(packr(mdD0Zd[1:54,i]))~meanc(packr(mdD4Zd[1:54,i]));          
 endif;

 if rows(packr(mdD0Z[55:107,i])) .lt min_no_obs;
 tabD2[i,.] = ids_prol[i,1]~miss(zeros(1,2),0);  
tabD2d[i,.] = ids_prol[i,1]~miss(zeros(1,2),0);  
 else;
 tabD2[i,.] = ids_prol[i,1]~meanc(packr(mdD0Z[55:107,i]))~meanc(packr(mdD4Z[55:107,i]));  
tabD2d[i,.] = ids_prol[i,1]~meanc(packr(mdD0Zd[55:107,i]))~meanc(packr(mdD4Zd[55:107,i]));  
 endif;

i=i+1;
endo;

"Multivariate Disagreement Statistics Table: disagreement values. Not diagonal";
"Table 2 in the Appendix";
ww = tabD~rankindx(tabD[.,2],1)~rankindx(tabD[.,4],1);
c31 = meanc((ww[.,3] .lt 0.05) + (ww[.,3] .gt 0.95));
c32 = meanc((ww[.,3] .lt 0.025) + (ww[.,3] .gt 0.975));
c41 = meanc((ww[.,4] .lt 0.05) + (ww[.,4] .gt 0.95));
c42 = meanc((ww[.,4] .lt 0.025) + (ww[.,4] .gt 0.975));
tex_table(sortc(ww,1));
" h=0 test rejns 10 and 5% ";c31;;c32;
" h=4 test rejns 10 and 5% ";c41;;c42;



"Multivariate Disagreement Statistics Table: disagreement values. Diagonal";
"id  h=0:Ave,  Equal:h=0,     h=4:Ave,  h=0:Rank,  h=4:Rank";  
ww = tabDd~rankindx(tabDd[.,2],1)~rankindx(tabDd[.,4],1);
c31 = meanc((ww[.,3] .lt 0.05) + (ww[.,3] .gt 0.95));
c31 = miss(zeros(1,2),0)~c31~miss(zeros(1,3),0);
c32 = meanc((ww[.,3] .lt 0.025) + (ww[.,3] .gt 0.975));
c32 = miss(zeros(1,2),0)~c32~miss(zeros(1,3),0);
tex_table(sortc(ww,1));
c31;
c32;

"Table 4";
"Spearman tests for disagreement between sample 1 and 2";
" S non-diag h=0   h=4 ; S diag h=0, h=4 ";
w1 = packr(tabD1[.,2]~tabD2[.,2]);
w2 = packr(tabD1[.,3]~tabD2[.,3]);
w3 = packr(tabD1d[.,2]~tabD2d[.,2]);
w4 = packr(tabD1d[.,3]~tabD2d[.,3]);
"number of respondents ";;rows(w1);;rows(w2);;rows(w3);;rows(w4);  
spearman(rankindx(w1[.,1],1),rankindx(w1[.,2],1))~spearman(rankindx(w2[.,1],1),rankindx(w2[.,2],1))~spearman(rankindx(w3[.,1],1),rankindx(w3[.,2],1))~spearman(rankindx(w4[.,1],1),rankindx(w4[.,2],1));

"Spearman tests for disagreement between h=0 and h=4";
" S non-diag  W E L. S diag W E L ";
w1 = packr(tabD[.,2]~tabD[.,4]);
w2 = packr(tabD1[.,2]~tabD1[.,3]);
w3 = packr(tabD2[.,2]~tabD2[.,3]);
w4 = packr(tabDd[.,2]~tabDd[.,4]);
w5 = packr(tabD1d[.,2]~tabD1d[.,3]);
w6 = packr(tabD2d[.,2]~tabD2d[.,3]);
"number of respondents ";;rows(w1);;rows(w2);;rows(w3);;rows(w4);;rows(w5);;rows(w6);  
spearman(rankindx(w1[.,1],1),rankindx(w1[.,2],1))~spearman(rankindx(w2[.,1],1),rankindx(w2[.,2],1))~spearman(rankindx(w3[.,1],1),rankindx(w3[.,2],1))~spearman(rankindx(w4[.,1],1),rankindx(w4[.,2],1))~spearman(rankindx(w5[.,1],1),rankindx(w5[.,2],1))~spearman(rankindx(w6[.,1],1),rankindx(w6[.,2],1));

/*********Forecast Efficiency Tests*********/

Experiment = 1;	do while Experiment <= 3;			  

if Experiment .== 1;
"***************************Dc**************************************************";
elseif Experiment .== 2;
"***************************Di**************************************************";
elseif Experiment .== 3;
"***************************Dy**************************************************";
endif;

/*********Tests for Prolific Forecaster, and of LHS forecasts versus actuals***************/
tab_pro = {};
i=1; do while i .le np; 			 

if Experiment .== 1;			
fdata = dates[38:144,1]~i_FDc0[38:144,newid[i,1]]~i_FDc1[37:143,newid[i,1]]~i_FDc2[36:142,newid[i,1]]~i_FDc3[35:141,newid[i,1]]~i_FDc4[34:140,newid[i,1]];
tab_pro = tab_pro|(ids_prol[i,1]~ORR(fdata[.,2:6])~ORR(Dc0[38:144,1]~fdata[.,3:6])~MZ(fdata[.,2:6])~MZa(fdata[.,2:6])~MZa(Dc0[38:144,1]~fdata[.,2:6])~MZcorrect(Dc0[38:144,1],fdata[.,2 6],i_FDc0C[38:144,newid[i,1]]~i_FDc4C[34:140,newid[i,1]],rmse_c_0[38:144,1],rmse_c_4[34:140,1]));

elseif Experiment .== 2;
fdata = dates[38:144,1]~i_FDi0[38:144,newid[i,1]]~i_FDi1[37:143,newid[i,1]]~i_FDi2[36:142,newid[i,1]]~i_FDi3[35:141,newid[i,1]]~i_FDi4[34:140,newid[i,1]];
tab_pro = tab_pro|(ids_prol[i,1]~ORR(fdata[.,2:6])~ORR(Di0[38:144,1]~fdata[.,3:6])~MZ(fdata[.,2:6])~MZa(fdata[.,2:6])~MZa(Di0[38:144,1]~fdata[.,2:6])~MZcorrect(Di0[38:144,1],fdata[.,2 6],i_FDi0C[38:144,newid[i,1]]~i_FDi4C[34:140,newid[i,1]],rmse_i_0[38:144,1],rmse_i_4[34:140,1]));

elseif Experiment .== 3;
fdata = dates[38:144,1]~i_FDy0[38:144,newid[i,1]]~i_FDy1[37:143,newid[i,1]]~i_FDy2[36:142,newid[i,1]]~i_FDy3[35:141,newid[i,1]]~i_FDy4[34:140,newid[i,1]];
tab_pro = tab_pro|(ids_prol[i,1]~ORR(fdata[.,2:6])~ORR(Dy0[38:144,1]~fdata[.,3:6])~MZ(fdata[.,2:6])~MZa(fdata[.,2:6])~MZa(Dy0[38:144,1]~fdata[.,2:6])~MZcorrect(Dy0[38:144,1],fdata[.,2 6],i_FDy0C[38:144,newid[i,1]]~i_FDy4C[34:140,newid[i,1]],rmse_y_0[38:144,1],rmse_y_4[34:140,1]));
 
endif;

i=i+1;
endo;

orr_tab = tab_pro[.,1:11];	 @orr results@;
mz_tab  = tab_pro[.,1 12:27]; @mz results@
mzcorrect_tab = tab_pro[.,1 28:33];

@MZ corrected ratio to uncorrected@;
mzc_tab = sortc(mzcorrect_tab,1);

orr_tab = sortc(orr_tab,1);
mz_tab  = sortc(mz_tab,1);

orr_tab =orr_tab|meanc(orr_tab .le 0.05)';
mz_tab  = mz_tab|meanc(mz_tab .le 0.05)';

if Experiment .== 1;     "Consumption";
elseif Experiment .== 2; "Investment";
elseif Experiment .== 3; "Output";	endif;

"Table 6";
"[Set correct_all = 0. scaling 1 to generate results in table 6]";
"OOS. Spearman: h=0  ";   
spearman(rankindx(mzcorrect_tab[.,2],1),rankindx(mzcorrect_tab[.,4],1));

"OOS. Spearman: h=4  ";   
spearman(rankindx(mzcorrect_tab[.,3],1),rankindx(mzcorrect_tab[.,5],1));

"Table 1 in the Appendix";
"MZ. Actuals on LHS";
format /rd 10,5;
tex_table(mz_tab[.,1 12 13 17]);		 @Prints results for MZ with Actuals on LHS@  

Experiment = Experiment + 1;  endo;

/**********************************PROCEDURES***********************************/


@Tests of equal means@
Proc(1)  = EqMeans(x1,x2,nl);
Local x1bar, x2bar, s1sq, s2sq, n1, n2, dof, tstat, num, den;
n1 = rows(packr(x1));
n2 = rows(packr(x2));

@no ACse@
s1sq =(stdc(packr(x1)))^2;
s2sq =(stdc(packr(x2)))^2;

@pth orger acse@
s1sq = acse(x1,nl);		@(.,1) implies normal estimates of variance@
s2sq = acse(x2,nl);


num = meanc(packr(x1)) - meanc(packr(x2));
den = (s1sq/n1) + (s2sq/n2);
tstat = num/SQRT(den);
dof = (den^2)/(  (s1sq^2/(n1*n1*(n1+1))) +  (s2sq^2/(n2*n2*(n2+1)))   );
dof = round(dof - 2);
RETP(cdfTc(tstat,dof));
ENDP;


@Tests of equal means@
@As EqMeans, but also returns the t-statistic, and n1 and n2@
Proc(1)  = EqMeansZ(x1,x2);
Local x1bar, x2bar, s1sq, s2sq, n1, n2, dof, tstat, num, den;
n1 = rows(packr(x1));
n2 = rows(packr(x2));

@no ACse@
s1sq =(stdc(packr(x1)))^2;
s2sq =(stdc(packr(x2)))^2;

@pth orger acse@
s1sq = acse(x1,4);														 
s2sq = acse(x2,4);


num = meanc(packr(x1)) - meanc(packr(x2));
den = (s1sq/n1) + (s2sq/n2);
tstat = num/SQRT(den);
dof = (den^2)/(  (s1sq^2/(n1*n1*(n1+1))) +  (s2sq^2/(n2*n2*(n2+1)))   );
dof = round(dof - 2);
RETP(cdfTc(tstat,dof)~tstat~n1~n2);
ENDP;


Proc(1) = acse(x,p);
Local n, s, i , wi, Wlag; 
n = rows(packr(x));
s = (1/(n-1))*(packr(x) - meanc(packr(x)))'(packr(x) - meanc(packr(x))) ;  
	if p .gt 1; 
     i=1; do while i < p;
	 wi =  1-(i/p);
	 Wlag = packr(x[1+i:rows(x),.]~x[1:rows(x)-i,.]);
     s = s + 2*wi*(1/rows(Wlag))*(Wlag[.,1]-meanc(Wlag[.,1]))'(Wlag[.,2]-meanc(Wlag[.,2])) ;
     @Bartlett weights@ 
     i = i+1; endo;
    endif;
retp(s);
endp;


@ -- Returns measure of dispersions	---@

@2nd argument =1 then quasi std. One half of 84th percentile minus the 16th percentile
			  =3 then IQ range @
@Input is rows (time periods) times columns (individuals)@
proc(1) = qstdc(x,selector);
local jj, n, y, n1, r ;
n=rows(x);
r = miss(zeros(n,1),0);
jj = 1; do while jj <= n;
y=sortc(packr(x[jj,.]'),1);
n1 = rows(y);
@quasi std@
if selector .== 1;
r[jj,1]=0.5*(y[round(0.84*n1),1]-y[round(0.16*n1),1]); 
elseif selector .== 3;
r[jj,1]= y[round(0.75*n1),1] - y[round(0.25*n1),1];
elseif selector .== 2;
r[jj,1] = stdc(y);
endif;
jj = jj +1;
endo;
retp(r);
endp;

PROC(1) = rej(x,pv);
Local res, i,n,c;
x = x[.,3:cols(x)];
n= cols(x);
res = miss(zeros(2,n),0); 
res = miss(zeros(1,n),0); 
i=1; do while i .le n;
c = x[.,i];
c = packr(c);
res[1,i] = meanc(c .le pv);
/*res[2,i] = rows(c);	 */ @Prints average no. of forecasters@
i=i+1; endo;
RETP(res);
ENDP;


PROC(1) = ORR(x);
Local i,f0,f1,f2,f3,f4,alln,n,xred,res,k,e,regX,s_sq,b,lr,Chitest,pvChi;
res = miss(zeros(4,1),0);
alln = miss(zeros(4,1),0);
k = miss(0,0);
Chitest = miss(zeros(4,1),0);
pvChi = miss(zeros(4,1),0);
i=1; do while i .le 4;
if i .== 1;
xred = packr(x[.,1 2]);
if rows(xred) .lt min_no_obs;  Chitest[i,1] = miss(0,0); GOTO jumptoi; endif;
f0 = xred[.,1];
f1 = xred[.,2];
n=rows(xred);
regX = ones(n,1)~f1;
lr = 0|1;
elseif i.== 2;
xred = packr(x[.,1 2 3]);
if rows(xred) .lt min_no_obs;  Chitest[i,1] = miss(0,0); GOTO jumptoi; endif;
f0 = xred[.,1];
f1 = xred[.,2];
f2 = xred[.,3];
n=rows(xred);
regX = ones(n,1)~f2~(f1-f2);
lr = 0|1|1;
elseif i.== 3;
xred = packr(x[.,1 2 3 4]);
if rows(xred) .lt min_no_obs;  Chitest[i,1] = miss(0,0); GOTO jumptoi; endif;
f0 = xred[.,1];
f1 = xred[.,2];
f2 = xred[.,3];
f3 = xred[.,4];
n=rows(xred);
regX = ones(n,1)~f3~(f1-f2)~(f2-f3);
lr = 0|1|1|1;
elseif i.== 4;
xred = packr(x[.,1 2 3 4 5]);
if rows(xred) .lt min_no_obs;  Chitest[i,1] = miss(0,0); GOTO jumptoi; endif;
f0 = xred[.,1];
f1 = xred[.,2];
f2 = xred[.,3];
f3 = xred[.,4];
f4 = xred[.,5];
n=rows(xred);
regX = ones(n,1)~f4~(f1-f2)~(f2-f3)~(f3-f4);
lr = 0|1|1|1|1;
endif;
alln[i,1] = n;
k = cols(regX);
b = invpd(regX'regX)*regX'f0;
e = f0 - regX*b;
if hcse == 0;
s_sq = (1/(n-k))*(e'e)*invpd(regX'regX);
else; 
s_sq = (1/(n-k))*(e.*regX)'(e.*regX);
s_sq = n*invpd(regX'regX)*s_sq*invpd(regX'regX);
endif;
Chitest[i,1] = (b-lr)'invpd(s_sq)*(b-lr);
jumptoi:
pvChi[i,1] = cdfChic(Chitest[i,1],k);
i=i+1; endo;
/* res = round(meanc(packr(alln)))|pvChi;
*/
res = minc(alln)|pvChi;
RETP(res');
ENDP;

@MZ test. Using shorter-horizon forecast on LHS, and `adjacent' forecasts, so no HACSE required@;
PROC(1) = MZ(x);
Local res,i,n,alln,k,e,ydep,regX,xred,s_sq,b,lr,Chitest;
res = miss(zeros(4,1),0);
k = miss(0,0);
alln = miss(zeros(4,1),0);
Chitest = miss(zeros(4,1),0);
i=1; do while i <= 4;
xred = x[.,i i+1];
xred = packr(xred);
if rows(xred) .ge min_no_obs;
 ydep = xred[.,1];
 regX = xred[.,2]; 
 n = rows(ydep);
 alln[i,1] = n;
 regX = ones(n,1)~regX;
 k = cols(regX);
 b = invpd(regX'regX)*regX'ydep;
 e = ydep - regX*b;
  if hcse == 0;
  s_sq = (1/(n-k))*(e'e)*invpd(regX'regX);
  else; 
  s_sq = (1/(n-k))*(e.*regX)'(e.*regX);
  s_sq = n*invpd(regX'regX)*s_sq*invpd(regX'regX);
  endif;
 lr = 0|1;
 Chitest[i,1] = (b-lr)'invpd(s_sq)*(b-lr); 
else;
Chitest[i,1] = miss(0,0); 
endif;
i=i+1; endo;
/*
res = round(meanc(alln))|cdfChic(Chitest,k);
*/
res = minc(alln)|cdfChic(Chitest,k);
RETP(res');
ENDP;

@MZ test. Using non-adjacent. Actual or forecast on LHS, HACSE required@;
PROC(1) = MZa(x);
Local res,i,n,alln,k,e,ydep,regX,xred,s_sq,b,lr,Chitest,p,hac,wi,lhs,rhs,eM,w,w1,w2,nM,nc;
hac = 1;
nc = cols(x) - 1;
res = miss(zeros(nc,1),0);
k = miss(0,0);
alln = miss(zeros(nc,1),0);
Chitest = miss(zeros(nc,1),0);
i=1; do while i <= nc;
nM = rows(x);
xred = x[.,1 i+1];		 lhs = xred[.,1]; rhs = ones(nM,1)~xred[.,2];
xred = packr(xred);
if rows(xred) .ge min_no_obs;
 ydep = xred[.,1];
 regX = xred[.,2]; 
 n = rows(ydep);
 alln[i,1] = n;
 regX = ones(n,1)~regX;
 k = cols(regX);
 b = invpd(regX'regX)*regX'ydep;
 e = ydep - regX*b;		 eM = lhs - rhs*b;
  
  @does not correct for missings@
  s_sq = (1/(n-k))*(e.*regX)'(e.*regX);

	if hac .== 1; 
     p=1; do while p < i;
	 wi =  1-(p/i);
     s_sq = s_sq + wi*(1/n)*(e[1+p:n,1].*regX[1+p:n,.])'(e[1:n-p].*regX[1:n-p,.])
                 + wi*(1/n)*(e[1+p:n,1].*regX[1:n-p,.])'(e[1:n-p].*regX[1+p:n,.]);
      @Bartlett weights@ 
     p = p+1; endo;
    endif;
  s_sq = n*invpd(regX'regX)*s_sq*invpd(regX'regX);


  @following code does correct for missings@
  w = packr(eM~lhs~rhs);
  s_sq = (1/(n-k))*(w[.,1].*w[.,3:k+2])'(w[.,1].*w[.,3:k+2]);

	if hac .== 1; 
     p=1; do while p < i;
	 wi =  1-(p/i);
	 w1 = packr(eM[1+p:nM,1]~rhs[1+p:nM,.]~eM[1:nM-p,1]~rhs[1:nM-p,.]);
	 w2 = packr(eM[1+p:nM,1]~rhs[1:nM-p,.]~eM[1:nM-p,1]~rhs[1+p:nM,.]);
	 
     s_sq = s_sq + wi*(1/rows(w1))*(w1[.,1].*w1[.,2:k+1])'(w1[.,k+2].*w1[.,k+3:2*k+2])
                 + wi*(1/rows(w2))*(w2[.,1].*w2[.,2:k+1])'(w2[.,k+2].*w2[.,k+3:2*k+2]);
      @Bartlett weights@ 
     p = p+1; endo;
    endif;
  w = packr(rhs);
  s_sq = n*invpd(w'w)*s_sq*invpd(w'w);
  
 lr = 0|1;
 Chitest[i,1] = (b-lr)'inv(s_sq)*(b-lr); 
else;
Chitest[i,1] = miss(0,0); 
endif;
i=i+1; endo;
/*
res = round(meanc(alln))|cdfChic(Chitest,k);
*/
res = minc(alln)|cdfChic(Chitest,k);

RETP(res');
ENDP;


@Uses MZ test with actuals on LHS.
Both in-sample (all observations), and out-of-sample (all but the first min_no_obs which are used for initial window)@
@First column of x is actuals, then forecasts h=0 to 4@
@need correct_all = 0 so that corrected	(xFC) and xF (corrected if correct_all = 1) differ@

PROC(1) = MZcorrect(xActual,xF,xFC,sc0,sc4);
Local res,j,ydep,regX,ydep0,regX0,ydep4,regX4,xred,b,p,wi,est_n,ntot,adj_f,e0,e4, res_Uncorr, adj_f0, adj_f4, rmsew0, rmsew4, unc1,cor1,unc4,cor4;
res           = miss(zeros(2,1),0);	    @ratio of corrected to uncorrected, h=0 and h=4 only@
res_Uncorr     = miss(zeros(2,1),0);	 @Uncorrected, scaled, h=0 and h=4 only@
unc1  = packr(xActual~xF[.,1]);
cor1  =	packr(xActual~xFC[.,1]);

unc4  = packr(xActual~xF[.,2]);
cor4  =	packr(xActual~xFC[.,2]);

res[1,1]        = rmse1(cor1[.,1],cor1[.,2])/rmse1(unc1[.,1],unc1[.,2]);
res[2,1]        = rmse1(cor4[.,1],cor4[.,2])/rmse1(unc4[.,1],unc4[.,2]);

e0 = (xActual[.,1] - xF[.,1])./sc0;
e4 = (xActual[.,1] - xF[.,2])./sc4;

res_Uncorr[1,1] = SQRT(meanc(packr(e0.*e0))); 
res_Uncorr[2,1] = SQRT(meanc(packr(e4.*e4)));

@whole sample h=0 corrected@
xred = unc1;
ydep0 = xred[.,1]; regX0 = xred[.,2];
regX0 = ones(rows(regX0),1)~regX0;
b = invpd(regX0'regX0)*regX0'ydep0;
adj_f0 = regX0*b;

@whole sample h=4 corrected@
xred = unc4;
ydep4 = xred[.,1]; regX4 = xred[.,2];
regX4 = ones(rows(regX4),1)~regX4;
b = invpd(regX4'regX4)*regX4'ydep4;
adj_f4 = regX4*b;

rmsew0 =  rmse1(ydep0,adj_f0)/rmse1(ydep0,regX0[.,2]);
rmsew4 =  rmse1(ydep4,adj_f4)/rmse1(ydep4,regX4[.,2]);

RETP(res'~res_Uncorr'~rmsew0~rmsew4);
ENDP;

@	Formats a Gauss matrix as a tex table@
proc(0) = tex_table(x);
local r,c,i,j;
r=rows(x);
c=cols(x);
"\\begin{table}";
"\\caption{} ";
"\\label{} ";
"\\begin{tabular}{} ";
"\\hline";
i=1; do while i <= r;
j=1; do while j <= c-1;
x[i,j];;" & ";;
j=j+1; endo;
x[i,c] " \\\\ ";
i=i+1;endo;
"\\hline";
"\\end{tabular} ";
"\\end{table} ";
retp;
endp;

@Formats a row as a line of a tex table@
proc(0) = tt(x);
local c,j;
c=cols(x);
j=1; do while j <= c-1;
x[1,j];;" & ";;
j=j+1; endo;
x[1,c] " \\\\ ";
retp;
endp;

Proc(1) = ForecAcc(e);
Local n, MSFEM, TMSFEM, DMSFEM, e1;
e1 = packr(e);
n = rows(e1);
if n .le 7;
TMSFEM = miss(0,0);
DMSFEM = miss(0,0);
else;
MSFEM  =  (1/n)*e1'e1;
TMSFEM = sumc(diag(MSFEM));
DMSFEM = det(MSFEM);
endif;
Retp(TMSFEM~DMSFEM~n);
endp;

Proc(1) = trace_errors(e);
Local tr_;
tr_ = e .* e;
tr_ = sumc(tr_');
Retp(tr_);
Endp;


proc(1) = spearman(r1,r2);
local SpearS,R, d, n, Fr, Zstat;
n = rows(r1);
d = r1 - r2;
R = sumc(d.*d);
SpearS = 1 - (6*R)/(n*(n*n -1 ));

@Fisher transformation@
Fr = 0.5*ln((1+SpearS)/(1-SpearS));
Zstat = Fr * SQRT((n-3)/1.06);
retp(SpearS|cdfNc(Zstat));
endp;

Proc(1) = rmse(a,f);
Local e,n,rmse;
e = packr(a - f');
n = rows(e);
rmse = SQRT((e'e)*(1/n));
RETP(rmse);
ENDP;

Proc(1) = aafe(a,f);
Local e,n,aafe;
e = packr(a - f');
n = rows(e);
aafe = meanc(abs(e));
RETP(aafe);
ENDP;

Proc(1) = rmse1(a,f);
Local e,n,rmse;
e = a - f;
n = rows(e);
rmse = SQRT((e'e)*(1/n));
RETP(rmse);
ENDP;


PROC(2) = c_f(x,in_sample,hh);
@x is actuals|forecasts for an individual@
@Replaces forecasts  by MZ-corrected forecasts@
@in-sample or real-time (out-of-sample)@
Local n,nn,k,ydep,regX,xred,b,adj_f,nred, b_all;
n = rows(x);
adj_f = miss(zeros(n,1),0);
b_all = miss(zeros(n,2),0);

xred = packr(x);
nred = rows(xred);
if nred .lt min_no_obs;		
adj_f = miss(zeros(n,1),0);
goto end2;
endif; 
if in_sample .== 1;
ydep = xred[.,1];
regX = ones(nred,1)~xred[.,2];
b = invpd(regX'regX)*regX'ydep;
adj_f = (ones(n,1)~x[.,2])*b;
b_all = ones(n,1) .*. b';

else;
k=1; do while k .<= n; 
  if rows(packr(x[1:k,.])) .lt min_no_obs + hh; @continue@;
  b = miss(zeros(2,1),0);
  elseif rows(packr(x[1:k,.])) .== min_no_obs + hh;  
	  xred = packr(x[1:k-1-hh,.]);
	  ydep = xred[.,1];
	  regX = xred[.,2];
	  regX = ones(rows(xred),1)~regX;
      b = invpd(regX'regX)*regX'ydep;
      adj_f[1:k,1] = (ones(k,1)~x[1:k,2])*b;
  elseif rows(packr(x[1:k,.])) .gt min_no_obs;
	  xred = packr(x[1:k-1-hh,.]);
	  ydep = xred[.,1];
	  regX = xred[.,2];
	  regX = ones(rows(xred),1)~regX;
      b = invpd(regX'regX)*regX'ydep;
      adj_f[k,1] = (ones(1,1)~x[k,2])*b;
  endif;

  b_all[k,.] = b'; 
k=k+1; endo;
	  
endif;
end2:
RETP(adj_f,meanc(packr(b_all[.,2])));
ENDP;

PROC(1) = MA11(y);
Local n, r, c, x, i, j; 
r = rows(y);
c = cols(y);
x = miss(zeros(r,c),0); 
j = 1; do while j .le c;
  i = 2; do while i .le r-1;
  x[i,j] = meanc(y[i-1:i+1,j]);
  i=i+1; endo;
j=j+1; endo;  
RETP(x);
ENDP;

PROC(1) = myHAC(eM,i);
@allows for correlations up to and including i@
@if i = 0, no AC@
Local e,n,nM,s_sq,p,wi,w1;

  @following code does correct for missings@
  e = packr(eM);				 @eM includes the missings@
  n = rows(e);
  nM = rows(eM);
  s_sq = (1/n)*(e - meanc(e))'(e - meanc(e));

     p=1; do while p < i+1;
	 wi =  1-(p/(i+1));
	 w1 = packr(eM[1+p:nM,1]~eM[1:nM-p,1]);
     s_sq = s_sq + 2*wi*(1/rows(w1))*((w1[.,1]-meanc(w1[.,1]))'(w1[.,2]-meanc(w1[.,2])));
      @Bartlett weights@ 
     p = p+1; endo;

RETP(s_sq);
ENDP;


Proc(1) = DM_test(ls1,ls2,nl);
@For two scores, possibly with missings@
Local d2, n, dt, dbar, se, dm;
d2 = ls1~ls2;
d2 = packr(d2);
n=rows(d2);
if n .gt min_no_obs;	
dt = d2[.,1] - d2[.,2];
dbar= meanc(dt);
se = SQRT(myHAC(ls1-ls2,nl));
dm = dbar/(se/sqrt(n));
dm = cdfN(dm);
else;
dm = miss(0,0);
endif;

RETP(dm~n);
Endp;


end;
